%global __brp_check_rpaths %{nil}
%global __requires_exclude ^libmpi
%global packname  fullRankMatrix
%global packver   0.1.0
%global rlibdir   /usr/local/lib/R/library

Name:             R-CRAN-%{packname}
Version:          0.1.0
Release:          1%{?dist}%{?buildtag}
Summary:          Generation of Full Rank Design Matrix

License:          MIT + file LICENSE
URL:              https://cran.r-project.org/package=%{packname}
Source0:          %{url}&version=%{packver}#/%{packname}_%{packver}.tar.gz


BuildRequires:    R-devel
Requires:         R-core
BuildArch:        noarch

%description
Creates a full rank matrix out of a given matrix. The intended use is for
one-hot encoded design matrices that should be used in linear models to
ensure that significant associations can be correctly interpreted.
However, 'fullRankMatrix' can be applied to any matrix to make it full
rank. It removes columns with only 0's, merges duplicated columns and
discovers linearly dependent columns and replaces them with linearly
independent columns that span the space of the original columns. Columns
are renamed to reflect those modifications. This results in a full rank
matrix that can be used as a design matrix in linear models. The algorithm
and some functions are inspired by Kuhn, M. (2008)
<doi:10.18637/jss.v028.i05>.

%prep
%setup -q -c -n %{packname}

# fix end of executable files
find -type f -executable -exec grep -Iq . {} \; -exec sed -i -e '$a\' {} \;
# prevent binary stripping
[ -d %{packname}/src ] && find %{packname}/src -type f -exec \
  sed -i 's@/usr/bin/strip@/usr/bin/true@g' {} \; || true
[ -d %{packname}/src ] && find %{packname}/src/Make* -type f -exec \
  sed -i 's@-g0@@g' {} \; || true
# don't allow local prefix in executable scripts
find -type f -executable -exec sed -Ei 's@#!( )*/usr/local/bin@#!/usr/bin@g' {} \;

%build

%install

mkdir -p %{buildroot}%{rlibdir}
%{_bindir}/R CMD INSTALL -l %{buildroot}%{rlibdir} %{packname}
test -d %{packname}/src && (cd %{packname}/src; rm -f *.o *.so)
rm -f %{buildroot}%{rlibdir}/R.css
# remove buildroot from installed files
find %{buildroot}%{rlibdir} -type f -exec sed -i "s@%{buildroot}@@g" {} \;

%files
%{rlibdir}/%{packname}
